//+------------------------------------------------------------------+
//|                                           test_count_click_0.mq5 |
//|                                                2016, Dina Paches |
//|                           https://login.mql5.com/ru/users/dipach |
//+------------------------------------------------------------------+
#property copyright "2016, Dina Paches"
#property link      "https://login.mql5.com/ru/users/dipach"
#property version   "1.23"
#property indicator_chart_window
#property indicator_plots   0
//---
#include <ObjectCreateAndSet.mqh>
#define NAME_INDICATOR             "count_click_0: "
#define QUANT_OBJ                  (6)// 
#define NUMBER_ALL                 ((QUANT_OBJ/2)-1)//    
#define X_DISTANCE                 (10) 
#define Y_DISTANCE                 (10)
#define WIDTH                      (60)
#define HEIGHT                     (20)
#define FONT_SIZE                  (9)
#define CLR_PANEL                  clrSilver//  
#define CLR_BORDER                 clrLavender// 
#define CORNER_PANEL               CORNER_RIGHT_UPPER
//---
int findPrefixObject,countClick[NUMBER_ALL+1];
string prefixObj,textObj[QUANT_OBJ],nameObj[QUANT_OBJ];
//---  :
color clrText[NUMBER_ALL+1]={clrDarkGreen,clrBrown,C'39,39,39'};
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
/*          
OnChartEvent():*/
   findPrefixObject=-1;
//---          :
   StringConcatenate(prefixObj,NAME_INDICATOR,Symbol(),"_",
                     EnumToString(Period()));
//---    :
   IndicatorSetString(INDICATOR_SHORTNAME,prefixObj);
//  ,      :
   LanguageTerminal();
//---   : 
   NameObjectPanel(QUANT_OBJ,nameObj,prefixObj,"i");
//---        
   ArrayInitialize(countClick,0);
//---    :
   for(int i=NUMBER_ALL;i>=0;i--){textObj[i]="0";}
//---  :
   PanelCreate();
//--- 
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---    :
   ObjectsDeleteAll(0,prefixObj,0,-1);
//---
   ChartRedraw();
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const int begin,
                const double &price[])
  {
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
//| ChartEvent function                                              |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
  {
//+------------------------------------------------------------------+
//|                             |
//+------------------------------------------------------------------+ 
   if(id==CHARTEVENT_OBJECT_CLICK)
     {
/*       ,  
,          . 
           
    :*/
      findPrefixObject=StringFind(sparam,prefixObj);
      //---
      if(findPrefixObject==0)
        {
         string clickedChartObject=sparam;
         findPrefixObject=-1;
         //---
         for(int i=QUANT_OBJ-2;i>=0;i--)
           {
/*     ,   :*/
            if(StringCompare(clickedChartObject,nameObj[i],true)==0)
              {
               int count=0,index=-1;
               //--- ,          :
               if(i==4|| i==1)//if "No"
                 {
                  index=1;
                  count=countClick[index]-1;
                 }
               else if(i==3 || i==0)//if "Yes"
                 {
                  index=0;
                  count=countClick[index]+1;
                 }
               else {return;}//,     
               //--- 
               int summ=countClick[NUMBER_ALL]+1;
                //---     :
               countClick[index]=count;
               countClick[NUMBER_ALL]=summ;
               //---     :
               textObj[index]=IntegerToString(count);
               textObj[NUMBER_ALL]=IntegerToString(summ);
               //---     :
               ObSetString(0,nameObj[index],OBJPROP_TEXT,textObj[index]);
               ObSetString(0,nameObj[NUMBER_ALL],OBJPROP_TEXT,textObj[NUMBER_ALL]);
               //---        :
               ChartRedraw();
               return;
              }// if(StringCompare(clickedChartObject,nameObj[i],true)==0)
           }//for(int i=QUANT_OBJ-2;i>=0;i--)
         return;
        }//if(findPrefixObject==0)
      return;
     }//if(id==CHARTEVENT_OBJECT_CLICK)
   return;
  }//void OnChartEvent
//+------------------------------------------------------------------+
//|   ,          |
//| :                                                       |
//+------------------------------------------------------------------+
void LanguageTerminal()
  {
   string language_t=NULL;
   language_t=TerminalInfoString(TERMINAL_LANGUAGE);
//---
   if(language_t=="Russian")
     {
      textObj[3]=": ";
      textObj[4]=": ";
      textObj[5]=": ";
     }
   else
     {
      textObj[3]="Yes: ";
      textObj[4]="No: ";
      textObj[5]="All: ";
     }
//---
   return;
  }
//+------------------------------------------------------------------+
//|                                        |
//+------------------------------------------------------------------+
void NameObjectPanel(int quant,// 
                     string &name[],
                     const string prefix,
                     const string dt)//-
  {
   string text=NULL;
//---
   for(int x=0;x<quant;x++)
     {
      StringConcatenate(text,prefix,"_",dt,"_",IntegerToString(x));
      name[x]=text;
     }
  }
//+------------------------------------------------------------------+
//|                                           |
//+------------------------------------------------------------------+
void PanelCreate(const long chart_ID=0,const int sub_window=0)
  {
   for(int i=NUMBER_ALL;i>=0;i--)
     {
      //---     :
      if(ObjectFind(chart_ID,nameObj[i])<0)
        {
         EditCreate(chart_ID,nameObj[i],sub_window,X_DISTANCE+WIDTH,
                    Y_DISTANCE+(HEIGHT)*(i),WIDTH,HEIGHT,
                    textObj[i],"Arial",FONT_SIZE,"\n",ALIGN_RIGHT,true,
                    CORNER_PANEL,clrText[i],CLR_PANEL,CLR_BORDER);
        }
     }
//---
   int correct=NUMBER_ALL+1;
//---
   for(int i=QUANT_OBJ-1;i>=correct;i--)
     {
      //---    :
      if(ObjectFind(chart_ID,nameObj[i])<0)
        {
         EditCreate(chart_ID,nameObj[i],sub_window,X_DISTANCE+(WIDTH*2),
                    Y_DISTANCE+(HEIGHT)*(i-correct),WIDTH,HEIGHT,
                    textObj[i],"Arial",FONT_SIZE,"\n",ALIGN_LEFT,true,
                    CORNER_PANEL,clrText[i-correct],CLR_PANEL,CLR_BORDER);
        }
     }
   return;
  }
//+------------------------------------------------------------------+
